#include "Matrices.h"

void Matrix4x4::InitializeIdentityMatrix()
{
	float IdentityMatrix[4][4] =
	{
		{ 1, 0, 0, 0 },
		{ 0, 1, 0, 0 },
		{ 0, 0, 1, 0 },
		{ 0, 0, 0, 1 }
	};

	for (int x = 0; x < 3; x++)
	{
		for (int y = 0; y < 3; y++)
		{
			Matrix[y][x] = IdentityMatrix[y][x];
		}
	}

}

void MultiplyMatrices(Matrix4x4& output, Matrix4x4 matrixA, Matrix4x4 matrixB)
{
	for (int y = 0; y < 3; y++)
	{
		for (int x = 0; x < 3; x++)
		{
			output[y][x] = (matrixA[y][0] * matrixB[0][x]) + (matrixA[y][1] * matrixB[1][x]) + (matrixA[y][2] * matrixB[2][x]) + (matrixA[y][3] * matrixB[3][x]);
		}
	}
}