#ifndef _SEMAPHORE_H_
#define _SEMAPHORE_H_

#include <mutex>
#include <condition_variable>

using std::condition_variable;
using std::mutex;
using std::unique_lock;

typedef unique_lock<mutex> sem_lock;

class semaphore
{
public:
	semaphore(int intial)
	{
		counter = intial;
	}

	void wait()
	{
		if (counter <= 0)
		{
			condition.wait(sem_lock(semaphore_mutex));
		}
		counter--;
	}
	void signal()
	{
		counter++;
		condition.notify_one();
	}

	void release_all()
	{
		condition.notify_all();
	}

private:
	condition_variable condition;
	int counter;
	mutex semaphore_mutex;
};
#endif